//stratiGrapher: draws stratigraphic section in PostScript
//Thu Jan 27 08:03:08 MET 2005 Peter A. Cejchan <cej@gli.cas.cz | tapique@tiscali.cz | pac@plan9.cz>

#include <u.h>
#include <libc.h>
#include <bio.h>
#include "plot.h"

#define WIDTH 2048	/* basal width of column */
#define MAXLENGTH 65536

#define INVSCALE 500
#define HCONST 0.1 
#define VCONST 0.1 
#define PCONST 0.2 

static int n, invscale, height, width, sumh, hardness, rocktype;
static double f[360];
static double fmax;
static int left = 0;
static int bottom = 0;

Biobuf	bin;
long	flag;
enum
{
	Fcirc	= 1<<0,
	Flin = 1<<1,
	Fpoly = 1<<2,
	Fbar	= 1<<3,
};

int readline(int f);
double findmax(void);
void drw(void);
void drw2(void);
void drw3(void);
void drw4(void);

void
main(int argc, char *argv[])
{
	int f;

	flag = 0;
	Binit(&bin, f, OREAD);

	ARGBEGIN{
	default:
		fprint(2, "rosie: unknown option %c\n", ARGC());
		exits("usage");
	case 'c':
		flag |= Fcirc;
		break;
	case 'l':
		flag |= Flin;
		break;
	case 'p':
		flag |= Fpoly;
		break;
	case 'b':
		flag |= Fbar;
		break;
	}ARGEND

///
	if(argc < 1) 
		f=0;
	else
	{
		f = open(argv[0], 0);
		if(f < 0) {
			fprint(2, "cannot open %s\n", argv[0]);
		}
	}
	invscale=INVSCALE;
	openpl();


	while(readline(f)){
		if((flag & Fcirc)&&(flag & Fbar)) drw();
	}

	close(f);
	closepl();

}


int 
readline(int f)
// read whitespace-delimited vector f[i] (external)
{
	char *buf, *av[MAXLENGTH];
	int  j;

	if((buf = Brdstr(&bin, '\n', 1)) != nil){
		n=tokenize(buf, av, MAXLENGTH);
			height=atof(av[0]);
			hardness=atof(av[1]);
			rocktype=atof(av[2]);
		free(buf);
	}
	return 1;
}


void
drw()
{
	float l1, l2, l3, llx, lly, lrx, lry, h1x, h1y, h2x, h2y, cx, cy, dx, dy, h3x, h3y, h4x, h4y, urx, ury, ulx, uly;
	double alpha, omega;
	width=WIDTH;
	scale(invscale);

	//calculate corners
	llx=ulx=left;
	lrx=urx=left+width;
	l1=HCONST*width*hardness;
	h1x=h2x=h3x=h4x=cx=dx=lrx+l1;
	lly=lry=h1y=bottom+sumh;
	uly=ury=h4y=lly+height;
	l3=PCONST*height;
	l2=VCONST*l3;
	cy=lly+l3;
	h2y=cy-l2;
	dy=uly-l3;
	h3y=dy+l2;

	sumh+=height;

	//draw "box"
	pen(SOLID);

	moveto(llx, lly);
	lineto(lrx, lry);
	curveto(h1x, h1y, h2x, h2y, cx, cy);
	lineto(dx, dy);
	curveto(h3x, h3y, h4x, h4y, urx, ury);
	lineto(ulx, uly);
	lineto(llx, lly);
	closepath();
	stroke();
	fill();
}

